package xyz.marsavic.gfxlab.graphics3d.raytracers;

import xyz.marsavic.geometry.Vector;
import xyz.marsavic.gfxlab.Color;
import xyz.marsavic.gfxlab.ColorFunctionT;
import xyz.marsavic.gfxlab.Vec3;
import xyz.marsavic.gfxlab.graphics3d.Hit;
import xyz.marsavic.gfxlab.graphics3d.Ray;
import xyz.marsavic.gfxlab.graphics3d.solids.HalfSpace;
import xyz.marsavic.gfxlab.graphics3d.solids.Parallelepiped;
import xyz.marsavic.utils.Numeric;


public class RayTracingTest implements ColorFunctionT {

	// Ball ball = Ball.cr(Vec3.xyz(0, 0, 2), 1);
	HalfSpace halfSpace = HalfSpace.pn(Vec3.xyz(0, -1, 0), Vec3.xyz(0, 1, 0));
	Parallelepiped parall1 = Parallelepiped.pabc(Vec3.xyz(-0.8, -0.5, 1.5),
			Vec3.xyz(1, 0, 0), Vec3.xyz(1, 1, 0.5), Vec3.xyz(0, 0, 1));
	Parallelepiped parall2 = Parallelepiped.pabc(Vec3.xyz(0.8, 0.0, 1.5),
			Vec3.xyz(2, 0, 1), Vec3.xyz(1, 5, 0), Vec3.xyz(0, 0, 1));
	@Override
	public Color at(double t, Vector p) {
		Ray ray = Ray.pq(Vec3.xyz(-Numeric.sinT(t), Numeric.sinT(t), 0), Vec3.zp(1, p));
		
		Hit hit1 = parall1.firstHit(ray);
		Hit hit2 = halfSpace.firstHit(ray);
		Hit hit3 = parall2.firstHit(ray);

		double tMin = Math.min(Hit.t(hit1), Math.min(Hit.t(hit2), Hit.t(hit3)));

		return Color.gray(1.0 / (1.0 + tMin));
	}
	
}
